#ifndef __OSPL_H_
#define __OSPL_H_

#include "rtosTypes.h"

#ifndef __KERNEL__

#include <pthread.h>
#include <stdio.h>
#include <errno.h>

typedef void (*rtosEntry_t) (char *arg1, int arg2, void *arg3);

typedef struct {
    char name[100];
    pthread_t thread_id;
}rtosTask_t;

typedef struct _uarg_t {
  rtosEntry_t entry_routine;
  int  priority;
  char *arg1;
  int   arg2;
  void *arg3;
}uarg_t;

typedef pthread_mutex_t rtosMutex_t;

#else

#include <linux/config.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/delay.h>
#include <linux/completion.h>
#include <linux/suspend.h>
#include <asm/io.h>
#include <asm/uaccess.h>
#include "rtosTypes.h"

typedef void (*rtosEntry_t) (char *arg1, int arg2, void *arg3, struct completion * exit);

typedef struct _karg_t {
    rtosEntry_t entry_routine;
    int  priority;
    char * arg1;
    int    arg2;
    void * arg3;
    struct completion * exit;
}karg_t;

typedef struct {
    char name[100];
    pid_t thread_pid;
    struct completion *exit;
    karg_t *karg;
}rtosTask_t;

typedef struct semaphore rtosMutex_t;


#endif

#endif /* __OSPL_H_ */
