/*uClinux vfork.c*/

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>

int main(int argc, char *argv[])
{
  pid_t pid;
  int ch_argc = 0;
  char *ch_argv[3];
  char child=0;

  /* Identify child, we use the magic argument argv[1]="child" */
  if (argc>=2 && !strcmp(argv[1],"child")) child=1;

  /* use vfork(), return values similar to fork() */

  if (!child) {
    if ((pid = vfork()) < 0) {
        printf("vfork() failed\n");
        exit(1);
    } else if (pid != 0) {
      /* Parent code */
      printf("%s:Parent exiting.\n",argv[0]);
      _exit(0);
    }

    /* 
     * Invoke the child exec here.We pass the special argument to 
     * identify the child
     */
    ch_argv[ch_argc++] = argv[0];
    ch_argv[ch_argc++] = "child";
    ch_argv[ch_argc++] = NULL;
    printf("%s %s %s\n",ch_argv[0], ch_argv[1], ch_argv[2]);
    execv(ch_argv[0], ch_argv);

    /* Note that If successful, execv never returns */
    printf("execv() failed\n");
    exit(1);

  } else { // Child code
    printf("%s:Starting child...\n",argv[0]);
    while (1) {
      sleep(5);
      printf("%s:...Child running\n",argv[0]);
    }
  }

}
